import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:laba1/presentation/details_page/details_page.dart';

import '../../domain/models/card.dart';

part 'card.dart';

class MyHomePage extends StatelessWidget {
  const MyHomePage({super.key, required this.title});

  final String title;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          title: Text(title),
          backgroundColor: Colors.amber,
        ),
        backgroundColor: Colors.yellow,
        body: const Body());
  }
}

class Body extends StatelessWidget {
  const Body({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final List<CardData> data = [
      CardData('orange',
          imageUrl:
              'https://kuban24.tv/wp-content/uploads/2023/10/photo_2023-10-02_16-08-02.jpg'),
      CardData("aboba",
          imageUrl:
              'https://masterpiecer-images.s3.yandex.net/5fa453a2d4c51a7:upscaled'),
      CardData("Hello world!!!",
          imageUrl:
              'https://m.media-amazon.com/images/I/81YqUbAZ0GL._AC_UF1000,1000_QL80_.jpg'),
      CardData('(=^･^=)',
          imageUrl:
              'https://i.pinimg.com/236x/c8/cc/24/c8cc24bba37a25c009647b8875aae0e3.jpg'),
      CardData('плохо быть старым ' + 'трезвым и больным, ' * 5,
          imageUrl:
              'https://images.genius.com/c754c6f1755acee741881d55985a6c34.865x865x1.jpg'),
    ];

    return Center(
      child: SingleChildScrollView(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: data
              .map((e) => _Card.fromData(
                    e,
                    onLike: (bool isLiked) {
                      _showSnackBar(context, isLiked);
                    },
                    onTap: () => _navToDetails(context, e),
                  ))
              .toList(),
        ),
      ),
    );
  }

  void _navToDetails(BuildContext context, CardData data) {
    Navigator.push(
      context,
      CupertinoPageRoute(builder: (context) => DetailsPage(data)),
    );
  }

  void _showSnackBar(BuildContext context, bool isLiked) {
    WidgetsBinding.instance.addPostFrameCallback((_) {
      ScaffoldMessenger.of(context).showSnackBar(SnackBar(
        content: Text(
          'Card ${isLiked ? 'liked' : 'unliked'}',
          style: Theme.of(context).textTheme.bodyLarge,
        ),
        backgroundColor: Colors.orangeAccent,
        duration: const Duration(seconds: 1),
      ));
    });
  }
}
